#include<iostream>
#include <algorithm>
#include<cmath>
using namespace std;
int main(){
int t;
cin>>t;
int r[t];
for(int i=0;i<t;i++){
    int n,m;
    int provera=1;
    long long razlika=0;
    long long mini=0;
    long long mini2=0;
    long long maxi=0;
    cin>>n>>m;
    long long a[n];
    long long b[m];
    for(int j=0;j<n;j++){
        cin>>a[j];
    }
    for(int j=0;j<m;j++){
        cin>>b[j];
    }
    sort(a,a+n);
    sort(b,b+m);
    razlika=a[n-1];
        for(int j=1;j<n;j++){
        if(razlika>a[j]-a[j-1])razlika=a[j]-a[j-1];
    }
    maxi=max(a[n-1],b[m-1]);
    mini=min(a[0],b[0]);
    mini2=a[0];
    long long x=mini2;
    long long l=maxi/razlika;
    long long o=l+1;
    long long c[o];
    for(int j=0;j<o;j++){
        c[j]=x;
        x+=razlika;
    }
        for(int j=0;j<o;j++){
             for(int q=0;q<m;q++){
            if(b[q]==c[j]){
                provera=0;
            }
        }
        }
for(int j=0;j<m;j++){
    if(c[0]-razlika==b[j]) provera=0;
}
if(provera==0)r[i]=0;
else r[i]=1;
}
for(int i=0;i<t;i++){
    cout<<r[i]<<endl;
}
}